/*****************************************************************************
 *
 * grail - Gesture Recognition And Instantiation Library
 *
 * Copyright (C) 2012 Canonical Ltd.
 *
 * This program is free software: you can redistribute it and/or modify it
 * under the terms of the GNU General Public License as published by the
 * Free Software Foundation, either version 3 of the License, or (at your
 * option) any later version.
 *
 * This program is distributed in the hope that it will be useful, but
 * WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License along
 * with this program.  If not, see <http://www.gnu.org/licenses/>.
 *
 ****************************************************************************/

#ifndef UTOUCH_GRAIL_REGULAR_RECOGNIZER_H_
#define UTOUCH_GRAIL_REGULAR_RECOGNIZER_H_

#include "v3/recognizer.h"

namespace utouch {
namespace grail {

class RegularRecognizer : public Recognizer {
 public:
  RegularRecognizer(UGHandle* handle, const UFDevice device, UFWindowId window);

  virtual bool atomic() const {return false;}
  virtual void ProcessFrameEvent(const UFEvent event);

 private:
  void HandleNewTouchForAcceptedGesture(UFTouchId touch_id,
                                        const SharedGesture& gesture);
  void HandleNewTouchForUnacceptedGesture(UFTouchId touch_id,
                                          const SharedGesture& gesture);
  void MatchSubscriptionsForEvent(const UFEvent event);
  void MatchOneTouchGestures(UFTouchId touch_id);
  void MatchTwoTouchGestures(UFTouchId touch_id);
  void MatchThreeTouchGestures(UFTouchId touch_id);
  void MatchFourTouchGestures(UFTouchId touch_id);
  void MatchFiveTouchGestures(UFTouchId touch_id);
};

} // namespace grail
} // namespace utouch
#endif
